/* eslint-disable @typescript-eslint/naming-convention */
import fs from "fs";
import { GenericDbField } from "../../../db/model/GenericDbField";
import * as vscode from "vscode";
import { GenericDbTable } from "../../../db/model/GenericDbTable";
import { AbstractTypeScriptLoopbackProcessor } from "./AbstractTypeScriptLoopbackProcessor";
import { TypescriptLoopbackModelProcessor } from "./TypescriptLoopbackModelProcessor";
import { GeneratorTool } from "../../../tools/GeneratorTool";

export class TypescriptLoopbackRepositoryProcessor extends AbstractTypeScriptLoopbackProcessor {
  // This processor can handle AI
  protected canUseAI?: boolean | undefined = false;

  // We need this processor to get folder
  private modelProcessor?: TypescriptLoopbackModelProcessor;

  getProcessorFolder(): string {
    return "repositories";
  }

  getProcessorName(): string {
    return "loopback_repository";
  }

  async process(): Promise<void> {
    this.modelProcessor = new TypescriptLoopbackModelProcessor(this.config, this.configProcessor, this.db);
    await this.defaultProcess();
  }

  protected async processTable(rTable: GenericDbTable): Promise<void> {
    if (rTable?.fields && rTable.fields.length > 0 && this.modelProcessor) {
      // Load templates
      var tpl = fs.readFileSync(this.getTemplateBasePath() + "tpl_loopback_repository_ts", "utf8");

      // Class model name
      var classModelName = this.processClassNameFromTable(rTable.tableName);
      // Class name
      var className = `${classModelName}Repository`;
      // Datasourcename (we use processClassNameFromTable to try to generate datasource name)
      var dataSourceName = this.configProcessor.extra_config?.datasource_name ?? this.processClassNameFromTable(this.db.getSchema());

      const modelTemplate = {
        className: className,
        classModelName: classModelName,
        modelFolder: this.modelProcessor.getProcessorFolder(),
        dataSourceName: dataSourceName,
      };

      // Careful, for loopback file names, there is no "_" we must put some "-" instead
      const fileNameForLoopback = this.convertFilenameForLoopback(rTable.tableName.toLowerCase());

      // Complete index.ts file if needed
      this.updateIndexImport(this.getOutProcessorPath(), `${fileNameForLoopback}.repository`);

      await this.writeTemplateToFile({
        rFilePath: `${this.getOutProcessorPath()}${fileNameForLoopback}.repository.ts`,
        rTemplate: tpl,
        rFieldsTemplate: modelTemplate,
        rFields: rTable?.fields,
      });
    }
  }

  getFieldAnnotation(rField: GenericDbField, rNum: number | undefined): string {
    if (rField && rField.type?.type) {
      let type = this.converter.fieldConvertToType(rField.type);
      let sqltype = this.converter.fieldConvertToSql(rField.type);
      let id = rNum;
      let scale;
      let precision: string | undefined = "";
      let dataLength: number | undefined = rField.type.length;
      let dataPrecision;
      let dataScale;
      let generated;

      if (rField.isAutogenerated) {
        generated = true;
      }

      switch (type?.targetType) {
        case "number":
          scale = 0;
          dataScale = 0;
          precision = dataLength && dataLength > 0 ? dataLength.toString() : undefined;
          dataPrecision = precision;
          dataLength = undefined;
          break;
      }
      let txt =
        "" +
        `\t@property({\n` +
        `\t\ttype: '${type?.targetType}',\n` +
        `\t\trequired: ${!rField.isNullable},\n` +
        `${ rField.isNullable ? '\t\tjsonSchema: {nullable: true},\n' : ''}` + // Field can be ommitted if nullable
        `${generated ? "\t\tgenerated: " + generated + ",\n" : ""}` +
        `${precision ? "\t\tprecision: " + precision + ",\n" : ""}` +
        `${scale ? "\t\tscale: " + scale + ",\n" : ""}` +
        `${id ? "\t\tid: " + id + ",\n" : ""}` +
        `\t\tmysql: {\n` +
        `\t\t\tcolumnName: '${rField.fieldName}',\n` +
        `\t\t\tdataType: '${sqltype}',\n` +
        `\t\t\tdataLength: ${dataLength ?? "null"},\n` +
        `\t\t\tdataPrecision: ${dataPrecision ?? "null"},\n` +
        `\t\t\tdataScale: ${dataScale ?? "null"},\n` +
        `\t\t\tnullable: '${rField.isNullable ? "Y" : "N"}',\n` +
        `\t\t},\n` +
        `\t})`;

      return txt;
    } else {
      vscode.window.showWarningMessage("No Field or Field type");
      return "";
    }
  }
}
